/*
 *  adsp_21488.h is forza driver for custom dsp
 *
 *  Copyright 2013,2014 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

#ifndef __ADSP_21488_FWDL_H
#define __ADSP_21488_FWDL_H


#define ADSP_DUMMY_DT      (0x00000000)
#define ADSP_MUTE_DIS      (0x21000000)
#define ADSP_MUTE_ENA      (0x21000001)
#define FORMATS_RD_HEAD    (0x22000000)
#define FORMATS_WR_HEAD    (0x23000000)
#define HEQ_RD_HEAD        (0x24000000)
#define HEQ_WR_HEAD        (0x25000000)
#define ADSP_HEQ_NORM      (HEQ_WR_HEAD + 0x00000001)
#define ADSP_HEQ_IMPR      (HEQ_WR_HEAD + 0x00000003)
#define ADSP_HEQ_DIS       (HEQ_WR_HEAD )
#define RATE_RD_HEAD       (0x26000000)
#define RATE_WR_HEAD       (0x27000000)
#define FILTER_RD_HEAD     (0x28000000)
#define FILTER_WR_HEAD     (0x29000000)
#define ADSP_FILTER_MODE_NORMAL      (FILTER_WR_HEAD + 0x00000000)
#define ADSP_FILTER_MODE_HI_PRE      (FILTER_WR_HEAD + 0x00000001)



#define ADSP_LPCM             (0 << 5)
#define ADSP_LossLess         (1 << 5)
#define ADSP_AAC              (2 << 5)
#define ADSP_MP3              (3 << 5)
#define ADSP_ATRAC            (4 << 5)

#define ADSP_BIT_16           ( 0 << 3)
#define ADSP_BIT_20           ( 1 << 3)
#define ADSP_BIT_24           ( 2 << 3)
#define ADSP_BIT_32           ( 3 << 3)

#define ADSP_SAMPLE_RATE_44_1  0
#define ADSP_SAMPLE_RATE_48    1
#define ADSP_SAMPLE_RATE_88_2  2
#define ADSP_SAMPLE_RATE_96    3
#define ADSP_SAMPLE_RATE_176_4 4
#define ADSP_SAMPLE_RATE_192   5
#define ADSP_SAMPLE_RATE_352_8 6
#define ADSP_SAMPLE_RATE_384   7


#define ADSP_VERSION  0x3C0C1FFF

unsigned int adsp_21488_send_data(struct snd_forza *chip, unsigned int d);
unsigned int adsp_21488_read_data(struct snd_forza *chip, unsigned int d);
void adsp_21488_fwdl(struct snd_forza *chip, struct ioctl_struct *p);
void adsp_21488_set_formats(struct snd_forza *chip, struct ioctl_struct *p);
void adsp_21488_set_heq_params(struct snd_forza *chip, struct ioctl_struct *p);

#endif
