/*
 *  dsp_ops.h is forza driver for custom dsp
 *
 *  Copyright 2013,2014 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */
#ifndef __DSP_FWDL_H
#define __DSP_FWDL_H

struct dsp_hw_access {
  void (*init)(struct snd_forza *chip,struct ioctl_struct *p);
  void (*reset)(struct snd_forza *chip, struct ioctl_struct *p);
  //  void (*fwdl)(struct snd_forza *chip,struct ioctl_struct *p);
  int (*fwdl)(struct snd_forza *chip,struct ioctl_struct *p);
  void (*mute)(struct snd_forza *chip,struct ioctl_struct *p);
  void (*heq)(struct snd_forza *chip,struct ioctl_struct *p);
  void (*filter)(struct snd_forza *chip,struct ioctl_struct *p);
  void (*status)(struct snd_forza *chip,struct ioctl_struct *p);
  int  (*formats)(struct snd_forza *chip,struct ioctl_struct *p);
  int  (*heq_params)(struct snd_forza *chip,struct ioctl_struct *p);
  void (*reg_wr)(struct snd_forza *chip,struct ioctl_struct *p);
  int  (*version)(struct snd_forza *chip);
  void (*remove)(struct snd_forza *chip);
  void (*fwdl_flag)(int flag);
  void (*recover)(struct snd_forza *chip, struct ioctl_struct *p);
  void (*reload)(struct snd_forza *chip, struct ioctl_struct *p);
};
int dsp_hw_create(struct snd_forza *chip);
int dsp_hw_remove(struct snd_forza *chip);

#endif
