/*
 *  forza_audio_controller.h is sound controller for custom fpga
 *
 *  Copyright 2013,2014 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

#ifndef __SOUND_FORZA_AUDIO_H
#define __SOUND_FORZA_AUDIO_H

#include <linux/types.h>


int forza_audio_remove(struct snd_forza *chip);
int forza_audio_create(struct snd_forza *chip);

struct forza_hw_audio {
  void (*init)(struct snd_forza *chip, unsigned char fmode);
  void (*reset)(struct snd_forza *chip, int reset);
  void (*mute)(struct snd_forza *chip ,int mute);
  void (*lmute)(struct snd_forza *chip ,int mute, int bit);
  void (*formatter)(struct snd_forza *chip, int mode);
  void (*set_default)(struct snd_forza *chip, unsigned char fmt);
  void (*set_fader_val)(struct snd_forza *chip, unsigned char fadeNo, unsigned int Val);
  void (*set_fader)(struct snd_forza *chip, unsigned char fadeNo);
  void (*set_pcm)(struct snd_forza *chip, 
		  unsigned int   SRate, unsigned char BWith,
		  unsigned short CFormat, unsigned short CRate
		  );
  void (*set_dsd)(struct snd_forza *chip, unsigned int SRate);
  void (*set_model)(struct snd_forza *chip, unsigned char fmode);
  void (*delay)(struct snd_forza *chip, unsigned char time);
  void (*debug_test)(struct snd_forza *chip, struct ioctl_struct *p);
  void (*debug_led)(struct snd_forza *chip, unsigned char mode);
  void (*delete)(struct snd_forza *chip);
  void (*att)(struct snd_forza *chip, int att_center, int  gain_value);
};

struct audio_pos{
  unsigned int u_auf;
  unsigned int u_io;
  unsigned int au_func;

};


#endif
