/*
 *  forza_pcm.h is sound driver for custom fpga
 *
 *  Copyright 2013,2014 Sony Corporation
 *
 *  This program is free software; you can redistribute  it and/or modify it
 *  under  the terms of  the GNU General  Public License as published by the
 *  Free Software Foundation;  version 2 of the  License.
 *
 *  THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR IMPLIED
 *  WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
 *  MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
 *  NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 *  NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
 *  USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
 *  ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 *  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *  You should have received a copy of the  GNU General Public License along
 *  with this program; if not, write  to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Suite 500, Boston, MA 02110-1335, USA.
 */

#ifndef __SOUND_FORZA_PCM_H
#define __SOUND_FORZA_PCM_H

#include <sound/pcm.h>
#include "forza.h"

struct snd_forza_pcm;
void snd_forza_playback_interrupt(struct snd_forza *forza);

enum snd_forza_pcm_type{
  PLAYBACK_MUSIC
};

struct snd_forza_music {
  struct snd_forza *chip;
  int unmber;
  u32 use: 1,
    pcm: 1,
    synth: 1,
    dsd: 1;
  void (*interrupt)(struct snd_forza *chip, struct snd_forza_sound *sound);
};
    
struct snd_forza_pcm {
  struct snd_forza *chip;
  enum snd_forza_pcm_type type;
  struct snd_pcm_substream *substream;
  struct snd_forza_music *music[2];
  unsigned int running;
  u32 pointer_called_cnt;   
  u32 irq_called_cnt;       
  u32 dma_area_loop_cnt;
  u32 dma_period_cnt;
  u32 previous;
  u32 period_size;   
  u32 periods;
  u32 period_pos;
  u32 sum;
  u32 buf_periods;
  u32 buffer_size;
  unsigned int dma_ptr;
  unsigned int cur_ptr;
  unsigned char *dma_area;	
  dma_addr_t dma_addr;		
  dma_addr_t dma_read_addr;     
  size_t dma_bytes;		
  u32 last_post;
};

#endif
